/*
 * Copyright 2004-2005 Trypticon
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.trypticon.snipsnap.bot;

import java.io.IOException;

import org.trypticon.commandbot.CommandBot;

import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import org.apache.log4j.Appender;
import org.apache.log4j.ConsoleAppender;
import org.apache.log4j.SimpleLayout;
import org.apache.log4j.Logger;
import org.apache.log4j.FileAppender;
import org.apache.log4j.Level;
import org.apache.commons.logging.Log;

/**
 * Default bot component implementation for plugging into SnipSnap.
 */
public class DefaultBotComponent extends CommandBot
    implements BotComponent
{
    /**
     * Logging channel.
     */
    //private static final Log log;

    static
    {
        if (!Logger.getRootLogger().getAllAppenders().hasMoreElements())
        {
            try
            {
                // Bootstrap the logging.
                Appender appender = new FileAppender(new SimpleLayout(), "commons.log");
                Logger.getRootLogger().addAppender(appender);
                Logger.getRootLogger().setLevel(Level.INFO);
            }
            catch (IOException e)
            {
                System.err.println("Problem establishing logging.");
                e.printStackTrace();
                System.exit(1);
            }
        }

        //log = LogFactory.getLog(DefaultBotComponent.class);
    }


    public DefaultBotComponent() throws IOException, JDOMException
    {
        super(loadConfig());
    }

    private static Element loadConfig() throws IOException, JDOMException
    {
        return new SAXBuilder().build("conf/bot-config.xml").getRootElement();
    }
}
